// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package clusters

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// GetClustersReader is a Reader for the GetClusters structure.
type GetClustersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetClustersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetClustersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetClustersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetClustersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetClustersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetClustersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetClustersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetClustersOK creates a GetClustersOK with default headers values
func NewGetClustersOK() *GetClustersOK {
	return &GetClustersOK{}
}

/*
GetClustersOK describes a response with status code 200, with default header values.

Response with Cluster objects
*/
type GetClustersOK struct {
	Payload *members_models.ClusterResponse
}

// IsSuccess returns true when this get clusters o k response has a 2xx status code
func (o *GetClustersOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get clusters o k response has a 3xx status code
func (o *GetClustersOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get clusters o k response has a 4xx status code
func (o *GetClustersOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get clusters o k response has a 5xx status code
func (o *GetClustersOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get clusters o k response a status code equal to that given
func (o *GetClustersOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get clusters o k response
func (o *GetClustersOK) Code() int {
	return 200
}

func (o *GetClustersOK) Error() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersOK  %+v", 200, o.Payload)
}

func (o *GetClustersOK) String() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersOK  %+v", 200, o.Payload)
}

func (o *GetClustersOK) GetPayload() *members_models.ClusterResponse {
	return o.Payload
}

func (o *GetClustersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.ClusterResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersUnauthorized creates a GetClustersUnauthorized with default headers values
func NewGetClustersUnauthorized() *GetClustersUnauthorized {
	return &GetClustersUnauthorized{}
}

/*
GetClustersUnauthorized describes a response with status code 401, with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetClustersUnauthorized struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this get clusters unauthorized response has a 2xx status code
func (o *GetClustersUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get clusters unauthorized response has a 3xx status code
func (o *GetClustersUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get clusters unauthorized response has a 4xx status code
func (o *GetClustersUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get clusters unauthorized response has a 5xx status code
func (o *GetClustersUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get clusters unauthorized response a status code equal to that given
func (o *GetClustersUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get clusters unauthorized response
func (o *GetClustersUnauthorized) Code() int {
	return 401
}

func (o *GetClustersUnauthorized) Error() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersUnauthorized  %+v", 401, o.Payload)
}

func (o *GetClustersUnauthorized) String() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersUnauthorized  %+v", 401, o.Payload)
}

func (o *GetClustersUnauthorized) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *GetClustersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersForbidden creates a GetClustersForbidden with default headers values
func NewGetClustersForbidden() *GetClustersForbidden {
	return &GetClustersForbidden{}
}

/*
GetClustersForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetClustersForbidden struct {
	AccessControlAllowOrigin string

	Payload *members_models.Error
}

// IsSuccess returns true when this get clusters forbidden response has a 2xx status code
func (o *GetClustersForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get clusters forbidden response has a 3xx status code
func (o *GetClustersForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get clusters forbidden response has a 4xx status code
func (o *GetClustersForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get clusters forbidden response has a 5xx status code
func (o *GetClustersForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get clusters forbidden response a status code equal to that given
func (o *GetClustersForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get clusters forbidden response
func (o *GetClustersForbidden) Code() int {
	return 403
}

func (o *GetClustersForbidden) Error() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersForbidden  %+v", 403, o.Payload)
}

func (o *GetClustersForbidden) String() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersForbidden  %+v", 403, o.Payload)
}

func (o *GetClustersForbidden) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *GetClustersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersNotFound creates a GetClustersNotFound with default headers values
func NewGetClustersNotFound() *GetClustersNotFound {
	return &GetClustersNotFound{}
}

/*
GetClustersNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetClustersNotFound struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this get clusters not found response has a 2xx status code
func (o *GetClustersNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get clusters not found response has a 3xx status code
func (o *GetClustersNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get clusters not found response has a 4xx status code
func (o *GetClustersNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get clusters not found response has a 5xx status code
func (o *GetClustersNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get clusters not found response a status code equal to that given
func (o *GetClustersNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get clusters not found response
func (o *GetClustersNotFound) Code() int {
	return 404
}

func (o *GetClustersNotFound) Error() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersNotFound  %+v", 404, o.Payload)
}

func (o *GetClustersNotFound) String() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersNotFound  %+v", 404, o.Payload)
}

func (o *GetClustersNotFound) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *GetClustersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersUnprocessableEntity creates a GetClustersUnprocessableEntity with default headers values
func NewGetClustersUnprocessableEntity() *GetClustersUnprocessableEntity {
	return &GetClustersUnprocessableEntity{}
}

/*
GetClustersUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetClustersUnprocessableEntity struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this get clusters unprocessable entity response has a 2xx status code
func (o *GetClustersUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get clusters unprocessable entity response has a 3xx status code
func (o *GetClustersUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get clusters unprocessable entity response has a 4xx status code
func (o *GetClustersUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get clusters unprocessable entity response has a 5xx status code
func (o *GetClustersUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get clusters unprocessable entity response a status code equal to that given
func (o *GetClustersUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get clusters unprocessable entity response
func (o *GetClustersUnprocessableEntity) Code() int {
	return 422
}

func (o *GetClustersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetClustersUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetClustersUnprocessableEntity) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *GetClustersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetClustersInternalServerError creates a GetClustersInternalServerError with default headers values
func NewGetClustersInternalServerError() *GetClustersInternalServerError {
	return &GetClustersInternalServerError{}
}

/*
GetClustersInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetClustersInternalServerError struct {
	Payload *members_models.Error
}

// IsSuccess returns true when this get clusters internal server error response has a 2xx status code
func (o *GetClustersInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get clusters internal server error response has a 3xx status code
func (o *GetClustersInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get clusters internal server error response has a 4xx status code
func (o *GetClustersInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get clusters internal server error response has a 5xx status code
func (o *GetClustersInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get clusters internal server error response a status code equal to that given
func (o *GetClustersInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get clusters internal server error response
func (o *GetClustersInternalServerError) Code() int {
	return 500
}

func (o *GetClustersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersInternalServerError  %+v", 500, o.Payload)
}

func (o *GetClustersInternalServerError) String() string {
	return fmt.Sprintf("[GET /clusters][%d] getClustersInternalServerError  %+v", 500, o.Payload)
}

func (o *GetClustersInternalServerError) GetPayload() *members_models.Error {
	return o.Payload
}

func (o *GetClustersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(members_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
