// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package events

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// NewPostEventsParams creates a new PostEventsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostEventsParams() *PostEventsParams {
	return &PostEventsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostEventsParamsWithTimeout creates a new PostEventsParams object
// with the ability to set a timeout on a request.
func NewPostEventsParamsWithTimeout(timeout time.Duration) *PostEventsParams {
	return &PostEventsParams{
		timeout: timeout,
	}
}

// NewPostEventsParamsWithContext creates a new PostEventsParams object
// with the ability to set a context for a request.
func NewPostEventsParamsWithContext(ctx context.Context) *PostEventsParams {
	return &PostEventsParams{
		Context: ctx,
	}
}

// NewPostEventsParamsWithHTTPClient creates a new PostEventsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostEventsParamsWithHTTPClient(client *http.Client) *PostEventsParams {
	return &PostEventsParams{
		HTTPClient: client,
	}
}

/*
PostEventsParams contains all the parameters to send to the API endpoint

	for the post events operation.

	Typically these are written to a http.Request.
*/
type PostEventsParams struct {

	/* EventRequest.

	   An array of new Event records
	*/
	EventRequest *members_models.EventRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post events params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostEventsParams) WithDefaults() *PostEventsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post events params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostEventsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post events params
func (o *PostEventsParams) WithTimeout(timeout time.Duration) *PostEventsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post events params
func (o *PostEventsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post events params
func (o *PostEventsParams) WithContext(ctx context.Context) *PostEventsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post events params
func (o *PostEventsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post events params
func (o *PostEventsParams) WithHTTPClient(client *http.Client) *PostEventsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post events params
func (o *PostEventsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithEventRequest adds the eventRequest to the post events params
func (o *PostEventsParams) WithEventRequest(eventRequest *members_models.EventRequest) *PostEventsParams {
	o.SetEventRequest(eventRequest)
	return o
}

// SetEventRequest adds the eventRequest to the post events params
func (o *PostEventsParams) SetEventRequest(eventRequest *members_models.EventRequest) {
	o.EventRequest = eventRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostEventsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.EventRequest != nil {
		if err := r.SetBodyParam(o.EventRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
