// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package favorites

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetFavoritesParams creates a new GetFavoritesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetFavoritesParams() *GetFavoritesParams {
	return &GetFavoritesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetFavoritesParamsWithTimeout creates a new GetFavoritesParams object
// with the ability to set a timeout on a request.
func NewGetFavoritesParamsWithTimeout(timeout time.Duration) *GetFavoritesParams {
	return &GetFavoritesParams{
		timeout: timeout,
	}
}

// NewGetFavoritesParamsWithContext creates a new GetFavoritesParams object
// with the ability to set a context for a request.
func NewGetFavoritesParamsWithContext(ctx context.Context) *GetFavoritesParams {
	return &GetFavoritesParams{
		Context: ctx,
	}
}

// NewGetFavoritesParamsWithHTTPClient creates a new GetFavoritesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetFavoritesParamsWithHTTPClient(client *http.Client) *GetFavoritesParams {
	return &GetFavoritesParams{
		HTTPClient: client,
	}
}

/*
GetFavoritesParams contains all the parameters to send to the API endpoint

	for the get favorites operation.

	Typically these are written to a http.Request.
*/
type GetFavoritesParams struct {

	/* XAuth0UserID.

	   Auth0 User Id
	*/
	XAuth0UserID string

	/* ID.

	   Unique Record ID
	*/
	ID *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get favorites params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetFavoritesParams) WithDefaults() *GetFavoritesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get favorites params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetFavoritesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get favorites params
func (o *GetFavoritesParams) WithTimeout(timeout time.Duration) *GetFavoritesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get favorites params
func (o *GetFavoritesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get favorites params
func (o *GetFavoritesParams) WithContext(ctx context.Context) *GetFavoritesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get favorites params
func (o *GetFavoritesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get favorites params
func (o *GetFavoritesParams) WithHTTPClient(client *http.Client) *GetFavoritesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get favorites params
func (o *GetFavoritesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXAuth0UserID adds the xAuth0UserID to the get favorites params
func (o *GetFavoritesParams) WithXAuth0UserID(xAuth0UserID string) *GetFavoritesParams {
	o.SetXAuth0UserID(xAuth0UserID)
	return o
}

// SetXAuth0UserID adds the xAuth0UserId to the get favorites params
func (o *GetFavoritesParams) SetXAuth0UserID(xAuth0UserID string) {
	o.XAuth0UserID = xAuth0UserID
}

// WithID adds the id to the get favorites params
func (o *GetFavoritesParams) WithID(id *string) *GetFavoritesParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the get favorites params
func (o *GetFavoritesParams) SetID(id *string) {
	o.ID = id
}

// WithLimit adds the limit to the get favorites params
func (o *GetFavoritesParams) WithLimit(limit *int64) *GetFavoritesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get favorites params
func (o *GetFavoritesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get favorites params
func (o *GetFavoritesParams) WithOffset(offset *int64) *GetFavoritesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get favorites params
func (o *GetFavoritesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetFavoritesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// header param X-Auth0-UserId
	if err := r.SetHeaderParam("X-Auth0-UserId", o.XAuth0UserID); err != nil {
		return err
	}

	if o.ID != nil {

		// query param id
		var qrID string

		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
