// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package invoices

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/members/members_models"
)

// NewPostInvoicesParams creates a new PostInvoicesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostInvoicesParams() *PostInvoicesParams {
	return &PostInvoicesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostInvoicesParamsWithTimeout creates a new PostInvoicesParams object
// with the ability to set a timeout on a request.
func NewPostInvoicesParamsWithTimeout(timeout time.Duration) *PostInvoicesParams {
	return &PostInvoicesParams{
		timeout: timeout,
	}
}

// NewPostInvoicesParamsWithContext creates a new PostInvoicesParams object
// with the ability to set a context for a request.
func NewPostInvoicesParamsWithContext(ctx context.Context) *PostInvoicesParams {
	return &PostInvoicesParams{
		Context: ctx,
	}
}

// NewPostInvoicesParamsWithHTTPClient creates a new PostInvoicesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostInvoicesParamsWithHTTPClient(client *http.Client) *PostInvoicesParams {
	return &PostInvoicesParams{
		HTTPClient: client,
	}
}

/*
PostInvoicesParams contains all the parameters to send to the API endpoint

	for the post invoices operation.

	Typically these are written to a http.Request.
*/
type PostInvoicesParams struct {

	/* InvoiceRequest.

	   An array of new Invoice records
	*/
	InvoiceRequest *members_models.InvoiceRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post invoices params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostInvoicesParams) WithDefaults() *PostInvoicesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post invoices params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostInvoicesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post invoices params
func (o *PostInvoicesParams) WithTimeout(timeout time.Duration) *PostInvoicesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post invoices params
func (o *PostInvoicesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post invoices params
func (o *PostInvoicesParams) WithContext(ctx context.Context) *PostInvoicesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post invoices params
func (o *PostInvoicesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post invoices params
func (o *PostInvoicesParams) WithHTTPClient(client *http.Client) *PostInvoicesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post invoices params
func (o *PostInvoicesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInvoiceRequest adds the invoiceRequest to the post invoices params
func (o *PostInvoicesParams) WithInvoiceRequest(invoiceRequest *members_models.InvoiceRequest) *PostInvoicesParams {
	o.SetInvoiceRequest(invoiceRequest)
	return o
}

// SetInvoiceRequest adds the invoiceRequest to the post invoices params
func (o *PostInvoicesParams) SetInvoiceRequest(invoiceRequest *members_models.InvoiceRequest) {
	o.InvoiceRequest = invoiceRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostInvoicesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.InvoiceRequest != nil {
		if err := r.SetBodyParam(o.InvoiceRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
