// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package industry_products

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDeleteIndustryProductParams creates a new DeleteIndustryProductParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteIndustryProductParams() *DeleteIndustryProductParams {
	return &DeleteIndustryProductParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteIndustryProductParamsWithTimeout creates a new DeleteIndustryProductParams object
// with the ability to set a timeout on a request.
func NewDeleteIndustryProductParamsWithTimeout(timeout time.Duration) *DeleteIndustryProductParams {
	return &DeleteIndustryProductParams{
		timeout: timeout,
	}
}

// NewDeleteIndustryProductParamsWithContext creates a new DeleteIndustryProductParams object
// with the ability to set a context for a request.
func NewDeleteIndustryProductParamsWithContext(ctx context.Context) *DeleteIndustryProductParams {
	return &DeleteIndustryProductParams{
		Context: ctx,
	}
}

// NewDeleteIndustryProductParamsWithHTTPClient creates a new DeleteIndustryProductParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteIndustryProductParamsWithHTTPClient(client *http.Client) *DeleteIndustryProductParams {
	return &DeleteIndustryProductParams{
		HTTPClient: client,
	}
}

/*
DeleteIndustryProductParams contains all the parameters to send to the API endpoint

	for the delete industry product operation.

	Typically these are written to a http.Request.
*/
type DeleteIndustryProductParams struct {

	/* IndustryProductID.

	   IndustryProduct record ID
	*/
	IndustryProductID *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete industry product params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteIndustryProductParams) WithDefaults() *DeleteIndustryProductParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete industry product params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteIndustryProductParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the delete industry product params
func (o *DeleteIndustryProductParams) WithTimeout(timeout time.Duration) *DeleteIndustryProductParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete industry product params
func (o *DeleteIndustryProductParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete industry product params
func (o *DeleteIndustryProductParams) WithContext(ctx context.Context) *DeleteIndustryProductParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete industry product params
func (o *DeleteIndustryProductParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete industry product params
func (o *DeleteIndustryProductParams) WithHTTPClient(client *http.Client) *DeleteIndustryProductParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete industry product params
func (o *DeleteIndustryProductParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndustryProductID adds the industryProductID to the delete industry product params
func (o *DeleteIndustryProductParams) WithIndustryProductID(industryProductID *string) *DeleteIndustryProductParams {
	o.SetIndustryProductID(industryProductID)
	return o
}

// SetIndustryProductID adds the industryProductId to the delete industry product params
func (o *DeleteIndustryProductParams) SetIndustryProductID(industryProductID *string) {
	o.IndustryProductID = industryProductID
}

// WithLimit adds the limit to the delete industry product params
func (o *DeleteIndustryProductParams) WithLimit(limit *int64) *DeleteIndustryProductParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the delete industry product params
func (o *DeleteIndustryProductParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the delete industry product params
func (o *DeleteIndustryProductParams) WithOffset(offset *int64) *DeleteIndustryProductParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the delete industry product params
func (o *DeleteIndustryProductParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteIndustryProductParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.IndustryProductID != nil {

		// query param industryProductId
		var qrIndustryProductID string

		if o.IndustryProductID != nil {
			qrIndustryProductID = *o.IndustryProductID
		}
		qIndustryProductID := qrIndustryProductID
		if qIndustryProductID != "" {

			if err := r.SetQueryParam("industryProductId", qIndustryProductID); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
