// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package industry_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/research/research_models"
)

// DeleteIndustryServiceReader is a Reader for the DeleteIndustryService structure.
type DeleteIndustryServiceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteIndustryServiceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteIndustryServiceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewDeleteIndustryServiceUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewDeleteIndustryServiceForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewDeleteIndustryServiceNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewDeleteIndustryServiceUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeleteIndustryServiceInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewDeleteIndustryServiceOK creates a DeleteIndustryServiceOK with default headers values
func NewDeleteIndustryServiceOK() *DeleteIndustryServiceOK {
	return &DeleteIndustryServiceOK{}
}

/*
DeleteIndustryServiceOK describes a response with status code 200, with default header values.

Response with Message Objects with Delete Status
*/
type DeleteIndustryServiceOK struct {
	AccessControlAllowOrigin string

	Payload *research_models.DeleteResponse
}

// IsSuccess returns true when this delete industry service o k response has a 2xx status code
func (o *DeleteIndustryServiceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete industry service o k response has a 3xx status code
func (o *DeleteIndustryServiceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete industry service o k response has a 4xx status code
func (o *DeleteIndustryServiceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete industry service o k response has a 5xx status code
func (o *DeleteIndustryServiceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete industry service o k response a status code equal to that given
func (o *DeleteIndustryServiceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the delete industry service o k response
func (o *DeleteIndustryServiceOK) Code() int {
	return 200
}

func (o *DeleteIndustryServiceOK) Error() string {
	return fmt.Sprintf("[DELETE /industryservices][%d] deleteIndustryServiceOK  %+v", 200, o.Payload)
}

func (o *DeleteIndustryServiceOK) String() string {
	return fmt.Sprintf("[DELETE /industryservices][%d] deleteIndustryServiceOK  %+v", 200, o.Payload)
}

func (o *DeleteIndustryServiceOK) GetPayload() *research_models.DeleteResponse {
	return o.Payload
}

func (o *DeleteIndustryServiceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.DeleteResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteIndustryServiceUnauthorized creates a DeleteIndustryServiceUnauthorized with default headers values
func NewDeleteIndustryServiceUnauthorized() *DeleteIndustryServiceUnauthorized {
	return &DeleteIndustryServiceUnauthorized{}
}

/*
DeleteIndustryServiceUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type DeleteIndustryServiceUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

// IsSuccess returns true when this delete industry service unauthorized response has a 2xx status code
func (o *DeleteIndustryServiceUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete industry service unauthorized response has a 3xx status code
func (o *DeleteIndustryServiceUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete industry service unauthorized response has a 4xx status code
func (o *DeleteIndustryServiceUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete industry service unauthorized response has a 5xx status code
func (o *DeleteIndustryServiceUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this delete industry service unauthorized response a status code equal to that given
func (o *DeleteIndustryServiceUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the delete industry service unauthorized response
func (o *DeleteIndustryServiceUnauthorized) Code() int {
	return 401
}

func (o *DeleteIndustryServiceUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /industryservices][%d] deleteIndustryServiceUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteIndustryServiceUnauthorized) String() string {
	return fmt.Sprintf("[DELETE /industryservices][%d] deleteIndustryServiceUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteIndustryServiceUnauthorized) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *DeleteIndustryServiceUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteIndustryServiceForbidden creates a DeleteIndustryServiceForbidden with default headers values
func NewDeleteIndustryServiceForbidden() *DeleteIndustryServiceForbidden {
	return &DeleteIndustryServiceForbidden{}
}

/*
DeleteIndustryServiceForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type DeleteIndustryServiceForbidden struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

// IsSuccess returns true when this delete industry service forbidden response has a 2xx status code
func (o *DeleteIndustryServiceForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete industry service forbidden response has a 3xx status code
func (o *DeleteIndustryServiceForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete industry service forbidden response has a 4xx status code
func (o *DeleteIndustryServiceForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete industry service forbidden response has a 5xx status code
func (o *DeleteIndustryServiceForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this delete industry service forbidden response a status code equal to that given
func (o *DeleteIndustryServiceForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the delete industry service forbidden response
func (o *DeleteIndustryServiceForbidden) Code() int {
	return 403
}

func (o *DeleteIndustryServiceForbidden) Error() string {
	return fmt.Sprintf("[DELETE /industryservices][%d] deleteIndustryServiceForbidden  %+v", 403, o.Payload)
}

func (o *DeleteIndustryServiceForbidden) String() string {
	return fmt.Sprintf("[DELETE /industryservices][%d] deleteIndustryServiceForbidden  %+v", 403, o.Payload)
}

func (o *DeleteIndustryServiceForbidden) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *DeleteIndustryServiceForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteIndustryServiceNotFound creates a DeleteIndustryServiceNotFound with default headers values
func NewDeleteIndustryServiceNotFound() *DeleteIndustryServiceNotFound {
	return &DeleteIndustryServiceNotFound{}
}

/*
DeleteIndustryServiceNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type DeleteIndustryServiceNotFound struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

// IsSuccess returns true when this delete industry service not found response has a 2xx status code
func (o *DeleteIndustryServiceNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete industry service not found response has a 3xx status code
func (o *DeleteIndustryServiceNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete industry service not found response has a 4xx status code
func (o *DeleteIndustryServiceNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete industry service not found response has a 5xx status code
func (o *DeleteIndustryServiceNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this delete industry service not found response a status code equal to that given
func (o *DeleteIndustryServiceNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the delete industry service not found response
func (o *DeleteIndustryServiceNotFound) Code() int {
	return 404
}

func (o *DeleteIndustryServiceNotFound) Error() string {
	return fmt.Sprintf("[DELETE /industryservices][%d] deleteIndustryServiceNotFound  %+v", 404, o.Payload)
}

func (o *DeleteIndustryServiceNotFound) String() string {
	return fmt.Sprintf("[DELETE /industryservices][%d] deleteIndustryServiceNotFound  %+v", 404, o.Payload)
}

func (o *DeleteIndustryServiceNotFound) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *DeleteIndustryServiceNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteIndustryServiceUnprocessableEntity creates a DeleteIndustryServiceUnprocessableEntity with default headers values
func NewDeleteIndustryServiceUnprocessableEntity() *DeleteIndustryServiceUnprocessableEntity {
	return &DeleteIndustryServiceUnprocessableEntity{}
}

/*
DeleteIndustryServiceUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type DeleteIndustryServiceUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

// IsSuccess returns true when this delete industry service unprocessable entity response has a 2xx status code
func (o *DeleteIndustryServiceUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete industry service unprocessable entity response has a 3xx status code
func (o *DeleteIndustryServiceUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete industry service unprocessable entity response has a 4xx status code
func (o *DeleteIndustryServiceUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete industry service unprocessable entity response has a 5xx status code
func (o *DeleteIndustryServiceUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this delete industry service unprocessable entity response a status code equal to that given
func (o *DeleteIndustryServiceUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the delete industry service unprocessable entity response
func (o *DeleteIndustryServiceUnprocessableEntity) Code() int {
	return 422
}

func (o *DeleteIndustryServiceUnprocessableEntity) Error() string {
	return fmt.Sprintf("[DELETE /industryservices][%d] deleteIndustryServiceUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *DeleteIndustryServiceUnprocessableEntity) String() string {
	return fmt.Sprintf("[DELETE /industryservices][%d] deleteIndustryServiceUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *DeleteIndustryServiceUnprocessableEntity) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *DeleteIndustryServiceUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteIndustryServiceInternalServerError creates a DeleteIndustryServiceInternalServerError with default headers values
func NewDeleteIndustryServiceInternalServerError() *DeleteIndustryServiceInternalServerError {
	return &DeleteIndustryServiceInternalServerError{}
}

/*
DeleteIndustryServiceInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type DeleteIndustryServiceInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

// IsSuccess returns true when this delete industry service internal server error response has a 2xx status code
func (o *DeleteIndustryServiceInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete industry service internal server error response has a 3xx status code
func (o *DeleteIndustryServiceInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete industry service internal server error response has a 4xx status code
func (o *DeleteIndustryServiceInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete industry service internal server error response has a 5xx status code
func (o *DeleteIndustryServiceInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this delete industry service internal server error response a status code equal to that given
func (o *DeleteIndustryServiceInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the delete industry service internal server error response
func (o *DeleteIndustryServiceInternalServerError) Code() int {
	return 500
}

func (o *DeleteIndustryServiceInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /industryservices][%d] deleteIndustryServiceInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteIndustryServiceInternalServerError) String() string {
	return fmt.Sprintf("[DELETE /industryservices][%d] deleteIndustryServiceInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteIndustryServiceInternalServerError) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *DeleteIndustryServiceInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
