// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package company_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetCompanyServicesParams creates a new GetCompanyServicesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetCompanyServicesParams() *GetCompanyServicesParams {
	return &GetCompanyServicesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetCompanyServicesParamsWithTimeout creates a new GetCompanyServicesParams object
// with the ability to set a timeout on a request.
func NewGetCompanyServicesParamsWithTimeout(timeout time.Duration) *GetCompanyServicesParams {
	return &GetCompanyServicesParams{
		timeout: timeout,
	}
}

// NewGetCompanyServicesParamsWithContext creates a new GetCompanyServicesParams object
// with the ability to set a context for a request.
func NewGetCompanyServicesParamsWithContext(ctx context.Context) *GetCompanyServicesParams {
	return &GetCompanyServicesParams{
		Context: ctx,
	}
}

// NewGetCompanyServicesParamsWithHTTPClient creates a new GetCompanyServicesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetCompanyServicesParamsWithHTTPClient(client *http.Client) *GetCompanyServicesParams {
	return &GetCompanyServicesParams{
		HTTPClient: client,
	}
}

/*
GetCompanyServicesParams contains all the parameters to send to the API endpoint

	for the get company services operation.

	Typically these are written to a http.Request.
*/
type GetCompanyServicesParams struct {

	/* Active.

	   Only retrieve active records?
	*/
	Active *bool

	/* CompanyServiceID.

	   CompanyService record ID
	*/
	CompanyServiceID *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get company services params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetCompanyServicesParams) WithDefaults() *GetCompanyServicesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get company services params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetCompanyServicesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get company services params
func (o *GetCompanyServicesParams) WithTimeout(timeout time.Duration) *GetCompanyServicesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get company services params
func (o *GetCompanyServicesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get company services params
func (o *GetCompanyServicesParams) WithContext(ctx context.Context) *GetCompanyServicesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get company services params
func (o *GetCompanyServicesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get company services params
func (o *GetCompanyServicesParams) WithHTTPClient(client *http.Client) *GetCompanyServicesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get company services params
func (o *GetCompanyServicesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithActive adds the active to the get company services params
func (o *GetCompanyServicesParams) WithActive(active *bool) *GetCompanyServicesParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get company services params
func (o *GetCompanyServicesParams) SetActive(active *bool) {
	o.Active = active
}

// WithCompanyServiceID adds the companyServiceID to the get company services params
func (o *GetCompanyServicesParams) WithCompanyServiceID(companyServiceID *string) *GetCompanyServicesParams {
	o.SetCompanyServiceID(companyServiceID)
	return o
}

// SetCompanyServiceID adds the companyServiceId to the get company services params
func (o *GetCompanyServicesParams) SetCompanyServiceID(companyServiceID *string) {
	o.CompanyServiceID = companyServiceID
}

// WithLimit adds the limit to the get company services params
func (o *GetCompanyServicesParams) WithLimit(limit *int64) *GetCompanyServicesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get company services params
func (o *GetCompanyServicesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get company services params
func (o *GetCompanyServicesParams) WithOffset(offset *int64) *GetCompanyServicesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get company services params
func (o *GetCompanyServicesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetCompanyServicesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Active != nil {

		// query param active
		var qrActive bool

		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {

			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}
	}

	if o.CompanyServiceID != nil {

		// query param companyServiceId
		var qrCompanyServiceID string

		if o.CompanyServiceID != nil {
			qrCompanyServiceID = *o.CompanyServiceID
		}
		qCompanyServiceID := qrCompanyServiceID
		if qCompanyServiceID != "" {

			if err := r.SetQueryParam("companyServiceId", qCompanyServiceID); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
