// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_models"
)

// GetContactsReader is a Reader for the GetContacts structure.
type GetContactsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetContactsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetContactsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetContactsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetContactsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetContactsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetContactsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetContactsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetContactsOK creates a GetContactsOK with default headers values
func NewGetContactsOK() *GetContactsOK {
	return &GetContactsOK{}
}

/*
GetContactsOK describes a response with status code 200, with default header values.

Response with Contact objects
*/
type GetContactsOK struct {
	Payload *sfgate_models.ContactResponse
}

// IsSuccess returns true when this get contacts o k response has a 2xx status code
func (o *GetContactsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get contacts o k response has a 3xx status code
func (o *GetContactsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get contacts o k response has a 4xx status code
func (o *GetContactsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get contacts o k response has a 5xx status code
func (o *GetContactsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get contacts o k response a status code equal to that given
func (o *GetContactsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get contacts o k response
func (o *GetContactsOK) Code() int {
	return 200
}

func (o *GetContactsOK) Error() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsOK  %+v", 200, o.Payload)
}

func (o *GetContactsOK) String() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsOK  %+v", 200, o.Payload)
}

func (o *GetContactsOK) GetPayload() *sfgate_models.ContactResponse {
	return o.Payload
}

func (o *GetContactsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.ContactResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsUnauthorized creates a GetContactsUnauthorized with default headers values
func NewGetContactsUnauthorized() *GetContactsUnauthorized {
	return &GetContactsUnauthorized{}
}

/*
GetContactsUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetContactsUnauthorized struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get contacts unauthorized response has a 2xx status code
func (o *GetContactsUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get contacts unauthorized response has a 3xx status code
func (o *GetContactsUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get contacts unauthorized response has a 4xx status code
func (o *GetContactsUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this get contacts unauthorized response has a 5xx status code
func (o *GetContactsUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this get contacts unauthorized response a status code equal to that given
func (o *GetContactsUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the get contacts unauthorized response
func (o *GetContactsUnauthorized) Code() int {
	return 401
}

func (o *GetContactsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetContactsUnauthorized) String() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetContactsUnauthorized) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetContactsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsForbidden creates a GetContactsForbidden with default headers values
func NewGetContactsForbidden() *GetContactsForbidden {
	return &GetContactsForbidden{}
}

/*
GetContactsForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type GetContactsForbidden struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get contacts forbidden response has a 2xx status code
func (o *GetContactsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get contacts forbidden response has a 3xx status code
func (o *GetContactsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get contacts forbidden response has a 4xx status code
func (o *GetContactsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get contacts forbidden response has a 5xx status code
func (o *GetContactsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get contacts forbidden response a status code equal to that given
func (o *GetContactsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get contacts forbidden response
func (o *GetContactsForbidden) Code() int {
	return 403
}

func (o *GetContactsForbidden) Error() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsForbidden  %+v", 403, o.Payload)
}

func (o *GetContactsForbidden) String() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsForbidden  %+v", 403, o.Payload)
}

func (o *GetContactsForbidden) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetContactsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsNotFound creates a GetContactsNotFound with default headers values
func NewGetContactsNotFound() *GetContactsNotFound {
	return &GetContactsNotFound{}
}

/*
GetContactsNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type GetContactsNotFound struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get contacts not found response has a 2xx status code
func (o *GetContactsNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get contacts not found response has a 3xx status code
func (o *GetContactsNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get contacts not found response has a 4xx status code
func (o *GetContactsNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get contacts not found response has a 5xx status code
func (o *GetContactsNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get contacts not found response a status code equal to that given
func (o *GetContactsNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get contacts not found response
func (o *GetContactsNotFound) Code() int {
	return 404
}

func (o *GetContactsNotFound) Error() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsNotFound  %+v", 404, o.Payload)
}

func (o *GetContactsNotFound) String() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsNotFound  %+v", 404, o.Payload)
}

func (o *GetContactsNotFound) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetContactsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsUnprocessableEntity creates a GetContactsUnprocessableEntity with default headers values
func NewGetContactsUnprocessableEntity() *GetContactsUnprocessableEntity {
	return &GetContactsUnprocessableEntity{}
}

/*
GetContactsUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetContactsUnprocessableEntity struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get contacts unprocessable entity response has a 2xx status code
func (o *GetContactsUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get contacts unprocessable entity response has a 3xx status code
func (o *GetContactsUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get contacts unprocessable entity response has a 4xx status code
func (o *GetContactsUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this get contacts unprocessable entity response has a 5xx status code
func (o *GetContactsUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this get contacts unprocessable entity response a status code equal to that given
func (o *GetContactsUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the get contacts unprocessable entity response
func (o *GetContactsUnprocessableEntity) Code() int {
	return 422
}

func (o *GetContactsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetContactsUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetContactsUnprocessableEntity) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetContactsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetContactsInternalServerError creates a GetContactsInternalServerError with default headers values
func NewGetContactsInternalServerError() *GetContactsInternalServerError {
	return &GetContactsInternalServerError{}
}

/*
GetContactsInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type GetContactsInternalServerError struct {
	Payload *sfgate_models.Error
}

// IsSuccess returns true when this get contacts internal server error response has a 2xx status code
func (o *GetContactsInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get contacts internal server error response has a 3xx status code
func (o *GetContactsInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get contacts internal server error response has a 4xx status code
func (o *GetContactsInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get contacts internal server error response has a 5xx status code
func (o *GetContactsInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get contacts internal server error response a status code equal to that given
func (o *GetContactsInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get contacts internal server error response
func (o *GetContactsInternalServerError) Code() int {
	return 500
}

func (o *GetContactsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetContactsInternalServerError) String() string {
	return fmt.Sprintf("[GET /contacts][%d] getContactsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetContactsInternalServerError) GetPayload() *sfgate_models.Error {
	return o.Payload
}

func (o *GetContactsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sfgate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
